#ifndef __QUICKSET_H__
#define __QUICKSET_H__

#include <set>
using namespace std;

class QuickSet {
	static const int MAXQ = 16;
	set<int>* realset;
	int qs[MAXQ], n;
public:
	QuickSet()
	{
		realset = NULL;
		n = 0;
	}
	~QuickSet()
	{
		if (realset) delete realset;
	}
	void insert(int value)
	{
		if (realset) realset->insert(value);
		else {
			for (int i = 0; i < n; i++) {
				if (qs[i] == value) return;
			}
			if (n == MAXQ) {
				realset = new set<int>;
				for (int i = 0; i < n; i++) realset->insert(qs[i]);
				realset->insert(value);
			} else {
				qs[n++] = value;
			}
		}
	}
	void getAllElements(vector<int>& res)
	{
		if (realset) {
			res.resize(realset->size());
			int i = 0;
			for (set<int>::iterator it = realset->begin(); it != realset->end(); ++it)
				res[i++] = *it;
		} else {
			res.resize(n);
			for (int i = 0; i < n; i++) res[i] = qs[i];
			sort(res.begin(), res.end());
		}
	}
};

#endif // __QUICKSET_H__
