#ifndef __UTILS_H__
#define __UTILS_H__

#include <stdarg.h>

#define FOR(i, n) for (int i = 0; i < (int) (n); i++)
#define REP(i, v) for (int i = 0; i < (int) (v.size()); i++)
#define INRANGE(x, y) ((x) >= 0 && (x) < cols && (y) >= 0 && (y) < rows)


#ifdef _WIN32
#include <windows.h>
double btime() { static bool inited = false; static DWORD clk0; if (!inited) { inited = true; clk0 = GetTickCount(); return 0.0; } return (GetTickCount() - clk0)*0.001; }
#else
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
double btime() {static bool inited = false;static int secs, usecs;struct timeval tv;if (!inited) {inited = true;gettimeofday(&tv, NULL);secs = tv.tv_sec;usecs = tv.tv_usec;return 0.0;}gettimeofday(&tv, NULL);return tv.tv_sec - secs + (tv.tv_usec - usecs)*0.000001;}
#endif
void debugf(const char * format, ...)
#ifdef __GNUC__
__attribute((format(printf, 1, 2)))
#endif
;

void debugf(const char* format, ...)
{
#ifdef DEBUG
	char buff[1024];
	va_list va;
	va_start(va, format);
	vsnprintf(buff, sizeof(buff), format, va);
	va_end(va);
	printf("%s", buff);
#endif
}

#endif // __UTILS_H__
